<!doctype html>
<html lang="en">
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1">
        <title>Signin Using OpenSSO API</title>
        
        <!-- Bootstrap core CSS -->
        <link href="./css/bootstrap.min.css" rel="stylesheet">

        <!-- Example CSS -->
        <link href="./css/example.css" rel="stylesheet">
    </head>
  <body class="text-center">
    
    <div id="login" class="form-signin">
        <h1 class="h3 mb-3 fw-normal">Sign in</h1>
        <hr>
        <div class="form-floating">
            <input type="text" class="form-control" id="username" placeholder="username">
            <label for="username">Username</label>
        </div>
        <div class="form-floating">
            <input type="password" class="form-control" id="password" placeholder="password">
            <label for="password">Password</label>
        </div>
        <button onclick="handleLogin()" class="w-100 btn btn-lg btn-primary">Sign In</a>
    </div>

    <div id="user-info" class="form-signin" style="display:none">
        <table class="table">
            <tbody class="text-left">
                <tr>
                    <th scope="row" colspan="2"><img id="picture" src="https://via.placeholder.com/150"></th>
                </tr>
                <tr>
                    <th scope="row">User ID</th>
                    <td><span id="user_id"></span></td>
                </tr>
                <tr>
                    <th scope="row">Username</th>
                    <td><span id="username2"></span></td>
                </tr>
                <tr>
                    <th scope="row">Name</th>
                    <td><span id="name"></span></td>
                </tr>
                <tr>
                    <th scope="row">Email</th>
                    <td><span id="email"></span></td>
                </tr>
            </tbody>
        </table>
        <button type="button" class="btn btn-danger" onclick="handleLogout()">Logout</button>
    </div>

    <div class="modal fade" id="modalMFA" tabindex="-1" aria-labelledby="mfa-label" aria-hidden="true">
        <div class="modal-dialog">
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title" id="mfa-label">Multi Factor Authentication</h5>
              <button type="button" class="btn-close bg-secondary" style="margin:-0.5rem -0.5rem 0.5rem auto;" data-bs-dismiss="modal" aria-label="Close"></button>
            </div>
            <div class="modal-body">
              <div id="x-email-otp" class="form-group" style="display: none;">
                <label for="email-otp">Email OTP Code</label>
                <input id="email-otp" type="text" class="form-control">
                <hr />
              </div>
              <div id="x-ga-otp" class="form-group" style="display: none;">
                <label for="ga-otp">Authenticator OTP Code</label>
                <input id="ga-otp" type="text" class="form-control mb-2">
              </div>
              <div class="d-grid gap-2">
                <button onclick="submitMFA(this)" type="button" class="btn btn-fill btn-primary">Submit</button>
              </div>
            </div>
          </div>
        </div>
      </div>

    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-C6RzsynM9kWDrMNeT87bh95OGNyZPhcTNXj1NW7RuBCsyN/o0jlpcV8Qyq46cDfL" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/browser-storage-class@1.1.1/dist/browser-storage-class.min.js"></script>
    <script src="https://cdn.jsdelivr.net/npm/axios/dist/axios.min.js"></script>
    <script src="./js/global.js"></script>
    <script>
        // CHANGE URL WITH YOUR OPENSSO DOMAIN
        var urlAPILogin = 'http://localhost:3000/api/user/login';
        var urlAPIToken = 'http://localhost:3000/api/oauth/request_token';
        // CHANGE WITH YOUR SSO KEY
        var SSO_Key = '94ecfcbd02ec4ccb8509fc371fc320b9';

        // Modals
        var modalMFA = new bootstrap.Modal(document.getElementById('modalMFA'), {
            keyboard: false
        });

        // Handle the UI
        function setLogin(bool, obj) {
            bool = (bool === undefined ? true : bool);
            obj = (obj === undefined ? null : obj);
            if(bool) {
                document.getElementById('login').style.display = 'none';
                document.getElementById('user-info').style.display = 'block';
                // fill data
                document.getElementById('picture').setAttribute('src', obj.gravatar);
                document.getElementById('user_id').innerHTML = obj.uid;
                document.getElementById('username2').innerHTML = obj.unm;
                document.getElementById('name').innerHTML = obj.name;
                document.getElementById('email').innerHTML = obj.mail;
            } else {
                document.getElementById('login').style.display = 'block';
                document.getElementById('user-info').style.display = 'none';
                // cleanup data
                document.getElementById('picture').setAttribute('src', 'https://via.placeholder.com/150');
                document.getElementById('user_id').innerHTML = '';
                document.getElementById('username2').innerHTML = '';
                document.getElementById('name').innerHTML = '';
                document.getElementById('email').innerHTML = '';
            }
        }

        function _requestToken(_cb) {
            axios({
                method: 'get',
                url: urlAPIToken,
                headers: {
                    'content-type': 'application/json',
                    'Access-Key': SSO_Key
                }
            })
            .then(function (response) {
                if(response.data && response.data.success) {
                    if(_cb && typeof _cb === 'function') {
                        return _cb(null, response.data.access_token);
                    }
                } else {
                    if(_cb && typeof _cb === 'function') {
                        return _cb(response.data.message);
                    }
                }
            })
            .catch(function (error) {
                return _cb(error.message);
            });
        }

        function handleLogin() {
            _requestToken(function(err, res) {
                if(err) return console.log(err);
                axios({
                    method: 'post',
                    url: urlAPILogin,
                    headers: {
                        'content-type': 'application/json',
                        'Access-Token': res
                    },
                    data: {
                        username: document.getElementById('username').value,
                        password: document.getElementById('password').value
                    }
                })
                .then(function (response) {
                    if(response.data && response.data.success) {
                        // save token to localstorage
                        var success = saveToken(response.data.token);
                        if(success) {
                            setLogin(true, getUserInfo());
                        }
                    }
                })
                .catch(function (error) {
                    if(error.response.status === 400) {
                        if(error.response.data.required) {
                            modalMFA.show();
                            var reqheader = error.response.data.required;
                            var is2FAEmail = false;
                            for(var i=0;i<reqheader.length;i++) {
                                document.getElementById(reqheader[i]).style.display = 'block';
                                if(reqheader[i] === 'x-email-otp') {
                                    is2FAEmail = true;
                                }
                            }
                            if(is2FAEmail) {
                                alert('We\'ve sent you an email with OTP code.');
                            }
                        } else {
                            alert(error.response.data.message);
                        }
                    } else {
                        alert(error.message);
                    }
                });
            });
        }

        function submitMFA(btn) {
            btn.disabled = true;
            var objPost = {
                method: 'post',
                url: urlAPILogin,
                headers: {'content-type': 'application/json'},
                data: {
                    username: document.getElementById('username').value,
                    password: document.getElementById('password').value
                }
            };
            var otpemail = document.getElementById('x-email-otp');
            if (otpemail && window.getComputedStyle(otpemail).display === 'block') {
                objPost.headers['x-email-otp'] = document.getElementById('email-otp').value;
            }
            var otpga = document.getElementById('x-ga-otp');
            if (otpga && window.getComputedStyle(otpga).display === 'block') {
                objPost.headers['x-ga-otp'] = document.getElementById('ga-otp').value;
            }
            axios(objPost).then(function(response) {
                if(response.data && response.data.success) {
                    alert(response.data.message);
                    var success = saveToken(response.data.token);
                    if(success) {
                        setLogin(true, getUserInfo());
                    }
                    cleanup();
                    modalMFA.hide();
                } else {
                    alert(response.data.message);
                }
            }).catch(function(error) {
                if(error.response.status === 401) {
                    alert(error.response.data.message);
                } else {
                    alert(error.message);
                }
            }).finally(function() {
                btn.disabled = false;
            });
        }

        function handleLogout() {
            logout(function(err, success) {
                if(err) return console.log(err);
                if(success) {
                    setLogin(false);
                    // you can set redirect here
                    // location.href= '/';
                }
            });
        }

        function cleanup() {
            document.getElementById('email-otp').value = '';
            document.getElementById('ga-otp').value = '';
        }

        // Onload
        (function() {
            // check token from localstorage
            checkToken(function(err, data) {
                if(err) return console.log(err);
                if(data) { // if token found and still active
                    setLogin(true, getUserInfo());
                } else {
                    setLogin(false);
                }
            });
        })();
    </script>
    </body>
</html>
